Index: NEMO/branches/2020/ticket2377/src/OCE/IOM/iom.F90
===================================================================
--- NEMO/branches/2020/ticket2377/src/OCE/IOM/iom.F90	(revision 12602)
+++ NEMO/branches/2020/ticket2377/src/OCE/IOM/iom.F90	(revision 12608)
@@ -547,5 +547,4 @@
         i = i + 1; fields(i)%vname="hbli";           fields(i)%grid="grid_N"
         i = i + 1; fields(i)%vname="wn";             fields(i)%grid="grid_N_3D"
-        i = i + 1; fields(i)%vname="a_fwb_b";        fields(i)%grid="grid_scalar"
         i = i + 1; fields(i)%vname="a_fwb";          fields(i)%grid="grid_scalar"
 
Index: NEMO/branches/2020/ticket2377/src/OCE/IOM/iom_def.F90
===================================================================
--- NEMO/branches/2020/ticket2377/src/OCE/IOM/iom_def.F90	(revision 12602)
+++ NEMO/branches/2020/ticket2377/src/OCE/IOM/iom_def.F90	(revision 12608)
@@ -67,5 +67,5 @@
    END TYPE file_descriptor
    TYPE(file_descriptor), DIMENSION(jpmax_files), PUBLIC ::   iom_file !: array containing the info for all opened files
-   INTEGER, PARAMETER, PUBLIC                   :: max_rst_fields = 97 !: maximum number of restart variables defined in iom_set_rst_vars
+   INTEGER, PARAMETER, PUBLIC                   :: max_rst_fields = 96 !: maximum number of restart variables defined in iom_set_rst_vars
    TYPE, PUBLIC :: RST_FIELD  
     CHARACTER(len=30) :: vname = "NO_NAME" ! names of variables in restart file
Index: NEMO/branches/2020/ticket2377/src/OCE/SBC/sbcfwb.F90
===================================================================
--- NEMO/branches/2020/ticket2377/src/OCE/SBC/sbcfwb.F90	(revision 12602)
+++ NEMO/branches/2020/ticket2377/src/OCE/SBC/sbcfwb.F90	(revision 12608)
@@ -35,6 +35,6 @@
    PUBLIC   sbc_fwb    ! routine called by step
 
-   REAL(wp) ::   a_fwb_b   ! annual domain averaged freshwater budget
-   REAL(wp) ::   a_fwb     ! for 2 year before (_b) and before year.
+   REAL(wp) ::   a_fwb     ! annual domain averaged freshwater budget from the
+                           ! previous year
    REAL(wp) ::   fwfold    ! fwfold to be suppressed
    REAL(wp) ::   area      ! global mean ocean surface (interior domain)
@@ -116,12 +116,10 @@
          IF( kt == nit000 ) THEN                      ! initialisation
             !                                         ! Read the corrective factor on precipitations (fwfold)
-            IF ( ln_rstart .AND. iom_varid( numror, 'a_fwb_b', ldstop = .FALSE. ) > 0     &
-               &           .AND. iom_varid( numror, 'a_fwb',   ldstop = .FALSE. ) > 0 ) THEN
+            IF ( ln_rstart .AND. iom_varid( numror, 'a_fwb',   ldstop = .FALSE. ) > 0 ) THEN
                IF(lwp) WRITE(numout,*) 'sbc_fwb : reading FW-budget adjustment from restart file'
-               CALL iom_get( numror, 'a_fwb_b', a_fwb_b, ldxios = lrxios )
                CALL iom_get( numror, 'a_fwb',   a_fwb,   ldxios = lrxios )
             ELSE
                CALL ctl_opn( inum, 'EMPave_old.dat', 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
-               READ ( inum, "(24X,I8,2ES24.16)" ) iyear, a_fwb_b, a_fwb
+               READ ( inum, "(24X,I8,2ES24.16)" ) iyear, a_fwb
                CLOSE( inum )
             END IF
@@ -131,8 +129,6 @@
             IF(lwp)WRITE(numout,*)'sbc_fwb : year = ',iyear  , ' freshwater budget correction = ', fwfold
             IF(lwp)WRITE(numout,*)'          year = ',iyear-1, ' freshwater budget read       = ', a_fwb
-            IF(lwp)WRITE(numout,*)'          year = ',iyear-2, ' freshwater budget read       = ', a_fwb_b
             !
             IF( lwxios ) THEN                         ! Activate output of restart variables
-               CALL iom_set_rstw_var_active( 'a_fwb_b' )
                CALL iom_set_rstw_var_active( 'a_fwb'   )
             END IF
@@ -141,5 +137,5 @@
          ikty = 365 * 86400 / rn_Dt                  !!bug  use of 365 days leap year or 360d year !!!!!!!
          IF( MOD( kt, ikty ) == 0 ) THEN
-            a_fwb_b = a_fwb                           ! mean sea level taking into account the ice+snow
+                                                      ! mean sea level taking into account the ice+snow
                                                       ! sum over the global domain
             a_fwb   = glob_sum( 'sbcfwb', e1e2t(:,:) * ( ssh(:,:,Kmm) + snwice_mass(:,:) * r1_rho0 ) )
@@ -161,5 +157,4 @@
             IF(lwp) WRITE(numout,*) '~~~~'
             IF( lwxios ) CALL iom_swap( cwxios_context )
-            CALL iom_rstput( kt, nitrst, numrow, 'a_fwb_b', a_fwb_b, ldxios = lwxios )
             CALL iom_rstput( kt, nitrst, numrow, 'a_fwb',   a_fwb,   ldxios = lwxios )
             IF( lwxios ) CALL iom_swap( cxios_context  )
@@ -168,5 +163,5 @@
          IF( kt == nitend .AND. lwm ) THEN            ! save fwfold value in a file (only one required)
             CALL ctl_opn( inum, 'EMPave.dat', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE., narea )
-            WRITE( inum, "(24X,I8,2ES24.16)" ) nyear, a_fwb_b, a_fwb
+            WRITE( inum, "(24X,I8,2ES24.16)" ) nyear, a_fwb
             CLOSE( inum )
          ENDIF